/* fadarp.p ASSET DEPRECIATION ARRAY                                   */


{mfdtitle.i "b+ "}


/* ********** Begin Translatable Strings Definition ********* */

&SCOPED-DEFINE fadarp_p_1 "Summary"
/* MaxLen: 24 Comment: Determines whether to print summary */

&SCOPED-DEFINE fadarp_p_2 "Include Retired Assets"
/* MaxLen: 39 Comment:  Flag to include retired assets */

&SCOPED-DEFINE fadarp_p_3 "Depreciation"
/* MaxLen: 39 Comment:  Flag to include retired assets */

&SCOPED-DEFINE fadarp_p_4 "Accumulated/Period"
/* MaxLen: 39 Comment:  Flag to include retired assets */

/* ********** End Translatable Strings Definition ********* */

/* Define Local Variables */
define variable l-asset like fa_id no-undo.
define variable l-asset1 like fa_id no-undo.
define variable l-book like fabk_id no-undo.
define variable l-book1 like fabk_id no-undo.
define variable l-summary like mfc_logical label {&fadarp_p_1} no-undo.
define variable inclRet   like mfc_logical label {&fadarp_p_2} no-undo.
/*SKH*/ define variable accumper like mfc_logical label {&fadarp_p_3} format {&fadarp_p_4} no-undo.
/*SKH*/ define variable vaccumper as character initial {&fadarp_p_4} format "X(18)" no-undo.

 /* Define Asset Depreciation Array form */
form
    l-asset   colon 25      l-asset1 colon 42 label {t001.i}
    l-book    colon 25      l-book1  colon 42 label {t001.i}
    l-summary colon 25
    inclRet   colon 25
/*SKH*/ accumper colon 25   vaccumper no-label skip
with frame a side-labels width 80 attr-space.

/* SET EXTERNAL LABELS */
setFrameLabels(frame a:handle).

{wbrp01.i &io-frame = "a"}

/* Begin Mainloop for Asset Depreciation Array */
 mainloop:
repeat:

   /* Allow asset ID and book to be updated. */
   if l-asset1 = hi_char then l-asset1 = "".
   if l-book1 = hi_char then l-book1 = "".
   display vaccumper with frame a.

   if c-application-mode <> "WEB":U then
       update l-asset
              l-asset1
              l-book
              l-book1
              l-summary
              inclRet
/*SKH*/       accumper
           with frame a.

   {wbrp06.i &command = update
             &fields = "l-asset l-asset1 l-book l-book1 l-summary inclRet accumper"}

   if (c-application-mode <> "WEB":U) or
      (c-application-mode = "WEB":U and
      (c-web-request begins "DATA":U))
   then do:

       bcdparm = "".
       {mfquoter.i l-asset}
       {mfquoter.i l-asset1}
       {mfquoter.i l-book}
       {mfquoter.i l-book1}
       {mfquoter.i l-summary}
       {mfquoter.i inclRet}
       {mfquoter.i accumper}

       /* Set the upper limits to max values if blank. */
       if l-asset1 = "" then l-asset1 = hi_char.
       if l-asset1 < l-asset then l-asset1 = l-asset.
       if l-book1 = "" then l-book1 = hi_char.
       if l-book1 < l-book then l-book1 = l-book.

   end. /* if c-application-mode ... */

   /* Adds printer for output with batch option */
/**   {mfselbpr.i "printer" 132}**/
   {mfselbpr.i "printer" 5000}

   /* Prints page heading for report */
   {mfphead.i}

   /* Calls the Asset Depreciation Array report program */
/*SKH* {gprun.i ""fadarpa.p"" "(input l-asset, */
/*SKH*/ {gprun.i ""xxfadarpa.p"" "(input l-asset,
                                   input l-asset1,
                                   input l-book,
                                   input l-book1,
                                   input l-summary,
                                   input inclRet,
                                   input accumper)"}

   /* Adds report trailer */
   {mfrtrail.i}

end. /*MAIN-LOOP*/