/* fadarpa.p PRINT DEPRECIATION ARRAY REPORT SUBROUTINE                 */



{mfdeclre.i}
{gplabel.i} /* EXTERNAL LABEL INCLUDE */


/* ********** Begin Translatable Strings Definition ********* */

&SCOPED-DEFINE fadarpa_p_1 "Period#"
/* MaxLen: 8 Comment: Asset depreciation period (ie 1, 2, 3) */

&SCOPED-DEFINE fadarpa_p_2 "Period Amt"
/* MaxLen: 16 Comment:  Asset depreciation for related period */

&SCOPED-DEFINE fadarpa_p_3 "Accum Dep Amt"
/* MaxLen: 16 Comment:  accumulated depreciation for period */

&SCOPED-DEFINE fadarpa_p_4 "Basis Amt"
/* MaxLen: 14 Comment:  Basis Amount */

&SCOPED-DEFINE fadarpa_p_5 "Adjustment"
/* MaxLen: 13 Comment:  Adjustment type */

&SCOPED-DEFINE fadarpa_p_6 "Period"
/* MaxLen: 10 Comment:  Year Period */

/* ********** End Translatable Strings Definition ********* */

{wbrp02.i}   /* Web enablement include */

/* DEFINE VARIABLES */
/* Input Parmameters */
define input parameter fromAsset like fa_id no-undo.
define input parameter toAsset like fa_id no-undo.
define input parameter FromBook like fabk_id no-undo.
define input parameter toBook like fabk_id no-undo.
define input parameter printTot like mfc_logical no-undo.
define input parameter inclRet like mfc_logical no-undo.
/*SKH*/ define input parameter accumper like mfc_logical no-undo.

/* CHARACTER */
define variable perDate like fabd_yrper format "x(7)" no-undo.
define variable yrPeriod like fabd_yrper no-undo.
define variable resType as character format "x(10)" no-undo.
define variable assetID like fa_id no-undo.
define variable book like fabk_id no-undo.
define variable totUnits like fabd_accup no-undo.
define variable translbl as character no-undo.

/* INTEGER */
define variable period as integer format ">>>>>>9" no-undo.
define variable resNum as integer no-undo.
define variable basisAmt like fabd_peramt no-undo.
define variable perDepr like fabd_peramt no-undo.
define variable accDepr like fabd_accamt no-undo.
define variable accumAmt like fabd_accamt no-undo.
define variable accDiff like fabd_accamt no-undo.
define variable mc-error-number  as integer format "9999" no-undo.

/* DEFINE TEMP TABLES */
/*SKH*/ define temp-table tt_ehdr
/*SKH*/     field th_id           like fa_id        /* ID                       X(12)             */
/*SKH*/     field th_facls_id     like fa_facls_id  /* CLASS                    X(8)              */
/*SKH*/     field th_desc         like fa_desc1     /* DESC                     X(50)             */
/*SKH*/     field th_fabk_id      like fab_fabk_id  /* BOOK                     X(4)              */
/*SKH*/     field th_basis_amt    like fabd_peramt  /* BASIS AMT                ->>>>,>>>,>>9.99< */
/*SKH*/     field th_famt_id      like fab_famt_id  /* METHOD                   X(8)              */
/*SKH*/     field th_life         like fab_life     /* LIFE                     ->>9.99<          */
/*SKH*/     field th_retired      like fabd_retired /* RETIRED                  yes/no            */
/*SKH*/     field th_entity       like fa_entity    /* ENTITY                   X(4)              */
/*SKH*/     field th_startdt      like fa_startdt   /* SVS DATE                 99/99/9999        */
/*SKH*/     field th_faloc        like fa_faloc_id  /* LOCATION                 X(8)              */
/*SKH*/     field th_per_acct     like faba_acct    /* PERIODIC ACC ACCOUNT     X(8)              */
/*SKH*/     field th_per_cc       like faba_cc      /* CC                       X(4)              */
/*SKH*/     field th_asst_acct    like faba_acct    /* ASSET ACC ACCOUNT        X(8)              */
/*SKH*/     field th_asst_cc      like faba_cc      /* CC                       X(4)              */
/*SKH*/     field th_ast_ssp_acct like faba_acct    /* ASSET SUSPENCE ACCOUNT   X(8)              */
/*SKH*/     field th_ast_ssp_cc   like faba_cc      /* CC                       X(4)              */
/*SKH*/     field th_tag          like fad_tag      /* TAG#                     X(16)             */
/*SKH*/ index th_id th_id ascending.

/*SKH*/ define temp-table tt_edet
/*SKH*/     field td_id        like fa_id         /* ID                */
/*SKH*/     field td_per_year  like fabd_yrper    /* PERIOD:YEAR       */
/*SKH*/     field td_per_date  like fabd_yrper    /* PERIOD:YEAR/MONTH */
/*SKH*/     field td_per_deper like fabd_peramt   /* PERIOD AMT    ->>>>,>>>,>>9.99< */
/*SKH*/     field td_acc_deper like fabd_accamt   /* ACCUM DEP AMT ->>>>,>>>,>>9.99< */
/*SKH*/ index  td_id td_id td_per_date
/*SKH*/ index  td_per_date td_per_date td_id.
/* Total by Column */
/*SKH*/ define temp-table tt_cdata
/*SKH*/     field tc_id as integer
/*SKH*/     field tc_per_date like fabd_yrper
/*SKH*/     field tc_tot_per_deper like fabd_peramt
/*SKH*/     field tc_tot_acc_deper like fabd_accamt
/*SKH*/ index tc_per_date tc_per_date.

/*SKH*/ define variable count_per as integer no-undo.
/*SKH*/ define variable gtotamt like fabd_accamt no-undo.
/*SKH*/ define variable desc1 as character no-undo.
/*SKH*/ define variable iCC as character no-undo.
/*SKH*/ define variable iCol as integer no-undo.
/*SKH*/ define variable lentag as integer no-undo.

/*DEFINE FUNCTIONS */
/*SKH*/ function getAcct returns character (input  iNbr   as character,
/*SKH*/                                     input  iAsset as character,
/*SKH*/                                     output iCC    as character):
/*SKH*/     iCC = "".
/*SKH*/     for last faba_det no-lock
/*SKH*/        where faba_domain = global_domain
/*SKH*/          and faba_fa_id = iAsset
/*SKH*/          and faba_acctype = iNbr:
/*SKH*/         iCC = faba_cc.
/*SKH*/         return faba_acct.
/*SKH*/     end.
/*SKH*/
/*SKH*/     return "".
/*SKH*/
/*SKH*/ end function.


/*SKH*/ function getTag returns character (input iAsset as character):
/*SKH*/
/*SKH*/     define variable lsttag as character no-undo.
/*SKH*/
/*SKH*/     lsttag = "".
/*SKH*/     for each fad_det no-lock
/*SKH*/        where fad_domain = global_domain
/*SKH*/          and fad_fa_id = iAsset:
/*SKH*/         lsttag = lsttag + (if lsttag > "" then ";" else "") + fad_tag.
/*SKH*/         leave.
/*SKH*/     end.
/*SKH*/
/*SKH*/     return lsttag.
/*SKH*/
/*SKH*/ end function.


/* Define Frame */
/**SKH*
define frame f-2
    period column-label {&fadarpa_p_1}
    perDate column-label {&fadarpa_p_6}
    perDepr column-label {&fadarpa_p_2}
    accumAmt column-label {&fadarpa_p_3}
    fabd_det.fabd_resrv
    resType column-label {&fadarpa_p_5}
with down no-box no-attr-space width 132.

/* SET EXTERNAL LABELS */
setFrameLabels(frame f-2:handle).

define frame f-4
    period column-label {&fadarpa_p_1}
    perDate column-label {&fadarpa_p_6}
    perDepr column-label {&fadarpa_p_2}
    accumAmt column-label {&fadarpa_p_3}
    fabd_resrv
    resType column-label {&fadarpa_p_5}
with down no-box no-attr-space width 132.

/* SET EXTERNAL LABELS */
setFrameLabels(frame f-4:handle).

define frame f-5
    period
    perDate
    perDepr
    accumAmt
    fabd_resrv
    resType
with down no-labels no-box no-attr-space width 132.
**/

/* SET CURRENCY DEPENDENT ROUNDING FORMATS */
for first gl_ctrl
   fields( gl_domain
           gl_rnd_mthd)
    where gl_domain = global_domain
  no-lock: end.

/* REPORT LOGIC */
/* Get each asset ID to report on */
for each fa_mstr
  fields( fa_id
          fa_facls_id
          fa_desc1
          fa_entity
          fa_startdt
          fa_faloc_id
        )
   where fa_domain = global_domain
     and fa_id >= fromAsset
     and fa_id <= toAsset
 no-lock:

    /* Report an asset ID for each book */
    for each fab_det
      fields( fab_domain
              fab_fa_id
              fab_fabk_id
              fab_life
              fab_famt_id
              fab_uplife
            )  no-lock
       where fab_domain = global_domain
         and fab_fa_id = fa_id
         and (fab_fabk_id >= fromBook and fab_fabk_id <= toBook)
       break by fab_fabk_id:

        if first-of(fab_fabk_id) then do:

            /* Get all depreciation dtls for the asset and book */
            for each fabd_det
              fields( fabd_domain
                      fabd_fa_id
                      fabd_fabk_id
                      fabd_yrper
                      fabd_accup
                      fabd_resrv
                      fabd_retired
                      fabd_peramt
                     ) no-lock
                where fabd_domain = global_domain
                  and fabd_fa_id = fa_id
                  and fabd_fabk_id = fab_fabk_id
                break by fabd_yrper:

/*SKH*/         if not inclRet and fabd_retired then
/*SKH*/             next.

                /* increment period if yr per exists & not 1st time */
                /* Only find basis amount if new assetID or book */
                /* Save asset/book for setting basis amt later */
                /* accumulated depreciation per period */
                /* Format depr date, set year period */
                /* Reset first pass flag & set reserve 0 type */
                /* set resNum to curr reserve */

                if assetID <> fabd_fa_id or
                   book <> fabd_fabk_id
                then do:
                    {gprunp.i "fapl" "p" "fa-get-basis" "(input  fabd_fa_id,
                                                          input  fabd_fabk_id,
                                                          output basisAmt)"}
                end.

                {gprunp.i "fapl" "p" "fa-get-perdep" "(input  fa_id,
                                                       input  fab_fabk_id,
                                                       input  fabd_yrper,
                                                       output perDepr)"}

                {gprunp.i "fapl" "p" "fa-get-accdep" "(input  fa_id,
                                                       input  fab_fabk_id,
                                                       input  fabd_yrper,
                                                       output accDepr)"}

                assign
                    period = (if first-of(fabd_yrper) then 1 else 0) + period
                    assetID = fabd_fa_id
                    book = fabd_fabk_id
                    totUnits = fabd_accup
                    perDate = substring(fabd_yrper,1,4)
                            + "/"
                            + substring(fabd_yrper,5,2)
                    yrPeriod = fabd_yrper
                    resType = if fabd_resrv = 0 then getTermLabel("ORIGINAL",10) else resType
                    resNum = fabd_resrv.

               /* check the Adj table to pull reserve value */
                for first faadj_mstr
                   fields( faadj_domain
                           faadj_fa_id
                           faadj_fabk_id
                           faadj_resrv
                           faadj_type
                          ) no-lock
                    where faadj_domain = global_domain
                      and faadj_fa_id = fabd_fa_id
                      and faadj_fabk_id = fabd_fabk_id
                      and faadj_resrv = fabd_resrv:

                    /* check the lang dtl for adjustment types */
                    {gplngn2a.i &file     = ""faadj_mstr""
                                &field    = ""faadj_type""
                                &code     = faadj_type
                                &mnemonic = resType
                                &label    = translbl}

                end. /* faadj_mstr */

/*SKH*/         for first tt_ehdr
/*SKH*/             where th_id = fa_id
/*SKH*/           no-lock: end.
/*SKH*/
/*SKH*/         if not available tt_ehdr then do:
/*SKH*/
/*SKH*/             desc1 = replace(fa_desc1,chr(34)," ").
/*SKH*/
/*SKH*/             create tt_ehdr.
/*SKH*/             assign th_id        = fa_id        /*ID*/
/*SKH*/                    th_facls_id  = fa_facls_id  /*class*/
/*SKH*/                    th_desc      = desc1        /*desc*/
/*SKH*/                    th_fabk_id   = fab_fabk_id  /*book*/
/*SKH*/                    th_basis_amt = basisAmt     /*basis amt*/
/*SKH*/                    th_famt_id   = fab_famt_id  /*method   */
/*SKH*/                    th_life      = fab_life     /*life     */
/*SKH*/                    th_retired   = fabd_retired /*retired  */
/*SKH*/                    th_entity    = fa_entity    /*entity   */
/*SKH*/                    th_startdt   = fa_startdt   /*svs date */
/*SKH*/                    th_faloc     = fa_faloc_id. /*location */
/*SKH*/             th_per_acct     = getAcct( "3", fa_id, output iCC). /*Periodic Acc Account*/
/*SKH*/             th_per_cc       = iCC.                              /*cc*/
/*SKH*/             th_asst_acct    = getAcct( "1", fa_id, output iCC). /*Asset Acc Account*/
/*SKH*/             th_asst_cc      = iCC.                              /*cc*/
/*SKH*/             th_ast_ssp_acct = getAcct( "7", fa_id, output iCC). /*Asset Suspence Account*/
/*SKH*/             th_ast_ssp_cc   = iCC.                              /*cc*/
/*SKH*/             th_tag          = getTag( fa_id).                   /* Tag# */
/*SKH*/         end. /* if not available tt_ehdr  */
/*SKH*/
/*SKH*/         for first tt_edet
/*SKH*/             where td_id       = fa_id
/*SKH*/               and td_per_date = perDate
/*SKH*/             exclusive-lock: end.
/*SKH*/
/*SKH*/         if not available tt_edet then do:
/*SKH*/             create tt_edet.
/*SKH*/             assign td_id       = fa_id
/*SKH*/                    td_per_year = entry(1,perDate,"/")
/*SKH*/                    td_per_date = perDate.
/*SKH*/         end.
/*SKH*/
/*SKH*/         assign td_per_deper = td_per_deper + fabd_det.fabd_peramt
/*SKH*/                td_acc_deper = td_acc_deper + (if last-of(fabd_yrper) then accDepr else 0).

                /* Print headers of report */
/**SKH*
                if line-counter = 1 then do with frame f-1:
                    /* SET EXTERNAL LABELS */
                    setFrameLabels(frame f-1:handle).
                    display skip(1)
                            fa_id
                            fa_desc1 at 30
                            skip
                            fab_fabk_id
                            basisAmt label {&fadarpa_p_4} at 30
                            skip
                            fab_famt_id
                            fab_life at 30
                            skip
                            fabd_retired
                            skip(1)
                        with frame f-1 down side-labels no-box no-attr-space width 132.
                end. /* if line-counter = 1 */

                /* Print column headers and details */
                if printTot = no then do:
                    Display period
                            perDate
                            fabd_det.fabd_peramt @ perDepr
                            fabd_det.fabd_resrv
                            resType
                        with frame f-2.

                    /* Print Basis Amount only at last-of period */
                    if last-of(fabd_yrper) then
                      display accDepr @ accumAmt with frame f-2.

                end. /* if printTot = no ... */
                else do:

                    /* if printTot = yes print only at last-of period */
                    if last-of(fabd_yrper) then
                        display period
                                perDate
                                perDepr
                                accDepr @ accumAmt
                                fabd_det.fabd_resrv
                                resType
                        with frame f-2.
                end.  /* else do ... */

                /* Page breaking */
                if page-size - line-counter < 3 then
                    page.
**/
                {mfrpchk.i}
            end.   /* for each fabd_det */

            /* Check to see if the asset is UOP */
            if can-find(first famt_mstr no-lock
                        where famt_domain = global_domain
                          and famt_id = fab_famt_id
                          and famt_type = "2")
            then do:
                /* Used to indicate the period amount is forecasted */
                resType = getTermLabel("FORECAST",10).

                /* If there are no fabd_det records for UOP asset, initialize
                   the yrPeriod and accumulated depreciation amount */
                if period = 0 then
                   assign yrPeriod = ""
                          accDepr = 0.

                /* Use the forecasted amount when the requested date
                   is greater than the year/period in fabd_det or if
                   no fabd_det records are available for the asset */
                for each fauop_det
                  fields( fauop_domain
                          fauop_fa_id
                          fauop_fabk_id
                          fauop_yrper
                          fauop_accup) no-lock
                   where fauop_domain = global_domain
                     and fauop_fa_id = fa_id
                     and fauop_fabk_id = fab_fabk_id
                     and fauop_yrper > yrPeriod
                   break by fauop_yrper:

                    if assetID <> fauop_fa_id or book <> fauop_fabk_id
                    then do:
                        {gprunp.i "fapl" "p" "fa-get-basis" "(input  fauop_fa_id,
                                                              input  fauop_fabk_id,
                                                              output basisAmt)"}
                    end.

                    {gprunp.i "fapl" "p" "fa-get-forecast-perdep"
                        "(input  fa_id,
                          input  fab_fabk_id,
                          input  fauop_yrper,
                          output perDepr)"}

                    {gprunp.i "mcpl" "p" "mc-curr-rnd"
                        "(input-output perDepr,
                          input gl_rnd_mthd,
                          output mc-error-number)"}
                    if mc-error-number <> 0 then do:
                        {mfmsg.i mc-error-number 3}
                    end.

                    assign
                        period = (if first-of(fauop_yrper) then 1 else 0) + period
                        assetID = fauop_fa_id
                        book = fauop_fabk_id
                        totUnits = totUnits + fauop_upper
                        perDate = substring(fauop_yrper,1,4)
                                + "/"
                                + substring(fauop_yrper,5,2).

/*SKH*/             for first tt_ehdr
/*SKH*/                 where th_id = fa_id
/*SKH*/               no-lock: end.
/*SKH*/
/*SKH*/             if not available tt_ehdr then do:
/*SKH*/                 desc1 = replace(fa_desc1,""""," ").
/*SKH*/                 create tt_ehdr.
/*SKH*/                 assign th_id        = fa_id       /*ID*/
/*SKH*/                        th_facls_id  = fa_facls_id /*class*/
/*SKH*/                        th_desc      = desc1       /*desc*/
/*SKH*/                        th_fabk_id   = fab_fabk_id /*book*/
/*SKH*/                        th_basis_amt = basisAmt    /*basis amt*/
/*SKH*/                        th_famt_id   = fab_famt_id /*method   */
/*SKH*/                        th_life      = fab_life    /*life     */
/*SKH*/                        th_retired   = ?           /*retired  */
/*SKH*/                        th_entity    = fa_entity   /*entity   */
/*SKH*/                        th_startdt   = fa_startdt  /*svs date */
/*SKH*/                        th_faloc     = fa_faloc.   /*location */
/*SKH*/                 th_per_acct     = getAcct( "3", fa_id, output iCC). /*Periodic Acc Account*/
/*SKH*/                 th_per_cc       = iCC.                              /*cc*/
/*SKH*/                 th_asst_acct    = getAcct( "1", fa_id, output iCC). /*Asset Acc Account*/
/*SKH*/                 th_asst_cc      = iCC.                              /*cc*/
/*SKH*/                 th_ast_ssp_acct = getAcct( "7", fa_id, output iCC). /*Asset Suspence Account*/
/*SKH*/                 th_ast_ssp_cc   = iCC.                              /*cc*/
/*SKH*/                 th_tag          = getTag( fa_id).                   /* Tag# */
/*SKH*/             end.

                    /* Print headers of report */
/**SKH*
                    if line-counter = 1 then do with frame f-3:
                        /* SET EXTERNAL LABELS */
                        setFrameLabels(frame f-3:handle).
                        display skip(1)
                                fa_id
                                fa_desc1 at 30
                                skip
                                fab_fabk_id
                                basisAmt label {&fadarpa_p_4} at 30
                                skip
                                fab_famt_id
                                fab_life at 30
                                skip(1)
                            with frame f-3 down side-labels no-box no-attr-space width 132.
                    end. /* if line-counter = 1 */
**/
                    /* ONLY ACCUMULATE FORECAST IF THE ADDITION DOES NOT
                       GO OVER BASIS AMT AND THE TOTAL UNITS ADDITION
                       DOESN'T GO OVER THE PRODUCTION UNITS */
                    if (accDepr + perDepr) > basisAmt or totUnits > fab_uplife
                    then do:
                        assign accDiff = (accDepr + perDepr) - basisAmt
                               perDepr = perDepr - accDiff
                               accDepr = basisAmt.
                    end.
                    else
                        assign accDepr = accDepr + perDepr.

                    /* Only Print column headers when beginning a new page.
                       This is due to the concatenation of the UOP records */
/**SKH
                    if line-counter = 8 then do with frame f-4:
                        display period column-label {&fadarpa_p_1}
                                perDate column-label {&fadarpa_p_6}
                                perDepr column-label {&fadarpa_p_2}
                                accDepr @ accumAmt column-label {&fadarpa_p_3}
                                resType
                            with frame f-4.
                    end. /* if line-counter = 8 */
                    else do with frame f-5:
                        Display period
                                perDate
                                perDepr
                                accDepr @ accumAmt
                                resType
                            with frame f-5.
                    end. /* else */

                    /* Page breaking */
                    if page-size - line-counter < 3 then
                        page.
**/
/*SKH*/             for first tt_edet
/*SKH*/                 where td_id       = fa_id
/*SKH*/                   and td_per_date = perDate
/*SKH*/                 exclusive-lock: end.
/*SKH*/
/*SKH*/             if not available tt_edet then do:
/*SKH*/                 create tt_edet.
/*SKH*/                 assign td_id       = fa_id
/*SKH*/                        td_per_year = entry(1,perDate,"/")
/*SKH*/                        td_per_date = perDate.
/*SKH*/             end.
/*SKH*/             assign td_per_deper = td_per_deper + perDepr
/*SKH*/                    td_acc_deper = td_acc_deper + accDepr.

                    {mfrpchk.i}

                    /* IF ACCUM DEPR ALREADY = BASIS THEN LEAVE.  THIS COULD
                       OCCUR IF FORECAST DATA IS BEING USED */
                    if accDepr = basisAmt or totUnits = fab_uplife then
                        leave.

                end. /* for each fauop_det */
            end. /* for first famt_mstr */

/*SKH*      page.*/
            assign totUnits = 0
                   period = 0.

        end. /* if first-of fab_fabk_id */

    end. /* for each fab_det */

end. /* do for each fa_mstr */


/* output data */
lentag = 0.
for each tt_ehdr no-lock by th_id:
    if lentag < length(th_tag) then lentag = length(th_tag).
end.
define variable lstyear as character no-undo.
lstyear = string(year(today) - 1, "9999") + "," +  /* prev year */
          string(year(today)    , "9999") + "," +  /* curr year */
          string(year(today) + 1, "9999").         /* next year */

/*Total of Row without prev curr and next year */
for each tt_edet
   where not can-do(lstyear,td_per_year)
   break by td_id
         by td_per_year:

    accumulate td_per_deper (sub-total by td_per_year). /*accumulate Total of Row by Year */
    accumulate td_acc_deper (sub-total by td_per_year). /*accumulate Total of Row by Year */

    if last-of(td_per_year) then
        assign td_per_deper = accum sub-total by td_per_year td_per_deper /*Total of Row by Year */
               td_acc_deper = accum sub-total by td_per_year td_acc_deper /*Total of Row by Year */
               td_per_date  = td_per_year.                                /* Save Year */
    else
        delete tt_edet.

    {mfrpchk.i}

end.

/*Total of Column */
count_per = 0.
for each tt_edet
   break by td_per_date
         by td_id:

    if first-of(td_per_date) then do:
        create tt_cdata.
        assign count_per = count_per + 1
               tc_id = count_per
               tc_per_date = td_per_date
               tc_tot_per_deper = 0
               tc_tot_acc_deper = 0.
    end.

    accumulate td_per_deper (sub-total by td_per_date). /*accumulate Total of Column */
    accumulate td_acc_deper (sub-total by td_per_date). /*accumulate Total of Column */

    if last-of(td_per_date) then
        assign tc_tot_per_deper = accum sub-total by td_per_date td_per_deper   /*Total of Column */
               tc_tot_acc_deper = accum sub-total by td_per_date td_acc_deper.  /*Total of Column */

    {mfrpchk.i}

end.

/* OUTPUT HEADER */
put unformatted "ID"                     at 1
                "CLASS"                  at 14
                "DESCRIPTION"            at 23
                "BOOK"                   at 74
                "BASSIS AMT"             to 95
                "METHOD"                 at 97
                "LIFE"                   to 113
                "RETIRED"                to 121
                "ENTITY"                 at 123
                "SVS DATE"               to 139
                "LOCATION"               at 141
                "PERIODIC ACC ACCOUNT"   at 150
                "CC"                     at 171
                "ASSET ACC ACCOUNT"      at 176
                "CC"                     at 194
                "ASSET SUSPENCE ACCOUNT" at 199
                "CC"                     at 222.

&SCOPED-DEFINE CURCOL 227
&SCOPED-DEFINE AMTSTP 18

iCol = {&CURCOL}.
put unformatted "TAG"                    at iCol.
iCol = iCol + lentag + 1.
put unformatted "ID"                     at iCol.
iCol = iCol + 12.
for each tt_cdata no-lock
      by tc_per_date:
    iCol = iCol + {&AMTSTP}.
    put unformatted "'" + tc_per_date to iCol.
end.
iCol = iCol + {&AMTSTP}.
put unformatted "GRAND TOTAL" to iCol skip.

put unformatted "------------"                                       at 1
                "--------"                                           at 14
                "--------------------------------------------------" at 23
                "----"                                               at 74
                "-----------------"                                  to 95
                "--------"                                           at 97
                "--------"                                           to 113
                "-------"                                            to 121
                "------"                                             at 123
                "----------"                                         to 139
                "--------"                                           at 141
                "--------------------"                               at 150
                "----"                                               at 171
                "-----------------"                                  at 176
                "----"                                               at 194
                "----------------------"                             at 199
                "----"                                               at 222.
iCol = {&CURCOL}.
put unformatted fill("-",lentag)                                     at iCol.
iCol = iCol + lentag + 1.
put unformatted "------------"                                       at iCol.
iCol = iCol + 12.
for each tt_cdata no-lock
      by tc_per_date:
    iCol = iCol + {&AMTSTP}.
    put unformatted "-----------------" to iCol.
end.
iCol = iCol + {&AMTSTP}.
put unformatted "-----------------" to iCol skip.

define variable retired as character no-undo.
/* Output data */
for each tt_ehdr no-lock by th_id:

    retired = if th_retired = ? then "" else string(th_retired).
    put unformatted th_id           at 1
                    th_facls_id     at 14
                    th_desc         at 23
                    th_fabk_id      at 74
                    th_basis_amt    to 95
                    th_famt_id      at 97
                    th_life         to 113
                    retired         to 121
                    th_entity       at 123
                    th_startdt      to 139
                    th_faloc        at 141
                    th_per_acct     at 150
                    th_per_cc       at 171
                    th_asst_acct    at 176
                    th_asst_cc      at 194
                    th_ast_ssp_acct at 199
                    th_ast_ssp_cc   at 222.
    iCol = {&CURCOL}.
    put unformatted th_tag          at iCol.
    iCol = iCol + lentag + 1.
    put unformatted th_id           at iCol.
    iCol = iCol + 12.

    /* Output amount */
    gtotamt = 0.
    for each tt_edet  where td_id = th_id no-lock,
        each tt_cdata where tc_per_date = td_per_date no-lock
                         by td_per_date:

        iCol = {&CURCOL} + lentag + 1 + 12 + (tc_id * {&AMTSTP}).
        if accumper then do:
            put unformatted td_acc_deper to iCol.
            gtotamt = gtotamt + td_acc_deper.
        end.
        else do:
            put unformatted td_per_deper to iCol.
            gtotamt = gtotamt + td_per_deper.
        end.
/**        {mfrpchk.i}**/

    end.

    iCol = {&CURCOL} + lentag + 1 + 12 + ((count_per + 1) * {&AMTSTP}).
    put unformatted gtotamt to iCol.

/**    {mfrpchk.i}**/

end.

/* Output ground Total */
iCol = {&CURCOL} + lentag + 1 + 12.
put unformatted "GRAND TOTAL:" to iCol.

for each tt_cdata no-lock by tc_per_date:

    iCol = iCol + {&AMTSTP}.
    if accumper then
        put unformatted tc_tot_acc_deper to iCol.
    else
        put unformatted tc_tot_per_deper to iCol.

/**    {mfrpchk.i}**/
end.

put unformatted "------------"                                       at 1
                "--------"                                           at 14
                "--------------------------------------------------" at 23
                "----"                                               at 74
                "-----------------"                                  to 95
                "--------"                                           at 97
                "--------"                                           to 113
                "-------"                                            to 121
                "------"                                             at 123
                "----------"                                         to 139
                "--------"                                           at 141
                "--------------------"                               at 150
                "----"                                               at 171
                "-----------------"                                  at 176
                "----"                                               at 194
                "----------------------"                             at 199
                "----"                                               at 222.
iCol = {&CURCOL}.
put unformatted fill("-",lentag)                                     at iCol.
iCol = iCol + lentag + 1.
put unformatted "------------"                                       at iCol.
iCol = iCol + 12.
for each tt_cdata no-lock
      by tc_per_date:
    iCol = iCol + {&AMTSTP}.
    put unformatted "-----------------" to iCol.
end.
iCol = iCol + {&AMTSTP}.
put unformatted "-----------------" to iCol skip.


/* Web Enablement include */
{wbrp04.i}

define stream sfa.
output stream sfa to xxfadarp.txt.
output stream sfa close.